Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jdesktop.swingx.plaf.basic
Class BasicHeaderUI

    java.lang.Object
      javax.swing.plaf.ComponentUI
          javax.swing.plaf.PanelUI
              org.jdesktop.swingx.plaf.HeaderUI
                  org.jdesktop.swingx.plaf.basic.BasicHeaderUI

    public class BasicHeaderUI

extends HeaderUI

Base implementation of `Header` UI.

PENDING JW: This implementation is unusual in that it does not keep a reference to the component it controls. Typically, such is only the case if the ui is shared between instances. Historical? A consequence is that the un/install methods need to carry the header as parameter. Which looks funny when at the same time the children of the header are instance fields in this. Should think about cleanup: either get rid off the instance fields here, or reference the header and remove the param (would break subclasses).

PENDING JW: keys for uidefaults are inconsistent - most have prefix "JXHeader." while defaultIcon has prefix "Header."

Author:
  rbair, rah003, Jeanette Winzenburg

Nested Class Summary
`protected class` | `BasicHeaderUI.DescriptionPane`

Field Summary
`protected BasicHeaderUI.DescriptionPane` | `descriptionPane`
`protected javax.swing.JLabel` | `imagePanel`
`protected javax.swing.JLabel` | `titleLabel`

Constructor Summary
`BasicHeaderUI()` Creates a new instance of BasicHeaderUI

Method Summary
`protected Painter` | `createBackgroundPainter()`
`static javax.swing.plaf.ComponentUI` | `createUI(javax.swing.JComponent c)` Returns an instance of the UI delegate for the specified component.
`protected void` | `installComponentDefaults(JXHeader header)` Configures the component default properties from the given header.
`protected void` | `installComponents(JXHeader header)` Creates, configures, adds contained components.
`protected void` | `installDefaults(JXHeader header)` Installs default header properties.
`protected void` | `installListeners(JXHeader header)`
`void` | `installUI(javax.swing.JComponent c)` Configures the specified component appropriate for the look and feel.
`protected void` | `onPropertyChange(JXHeader h, java.lang.String propertyName, java.lang.Object oldValue, java.lang.Object newValue)`
`protected void` | `uninstallComponentDefaults(JXHeader header)` Uninstalls component defaults.
`protected void` | `uninstallComponents(JXHeader header)` Unconfigures, removes and nulls contained components.
`protected void` | `uninstallDefaults(JXHeader h)` Uninstalls the given header's default properties.
`protected void` | `uninstallListeners(JXHeader h)`
`void` | `uninstallUI(javax.swing.JComponent c)` Reverses configuration which was done on the specified component during `installUI`.

Methods inherited from class javax.swing.plaf.ComponentUI
`contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, paint, update`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### titleLabel

    protected javax.swing.JLabel titleLabel

### descriptionPane

    protected BasicHeaderUI.DescriptionPane descriptionPane

### imagePanel

    protected javax.swing.JLabel imagePanel

Constructor Detail

### BasicHeaderUI

    public BasicHeaderUI()

  Creates a new instance of BasicHeaderUI

Method Detail

### createUI

    public static javax.swing.plaf.ComponentUI createUI(javax.swing.JComponent c)

  Returns an instance of the UI delegate for the specified component. Each subclass must provide its own static `createUI` method that returns an instance of that UI delegate subclass. If the UI delegate subclass is stateless, it may return an instance that is shared by multiple components. If the UI delegate is stateful, then it should return a new instance per component. The default implementation of this method throws an error, as it should never be invoked.

### installUI

    public void installUI(javax.swing.JComponent c)

  Configures the specified component appropriate for the look and feel. This method is invoked when the `ComponentUI` instance is being installed as the UI delegate on the specified component. This method should completely configure the component for the look and feel, including the following:
  1. Install any default property values for color, fonts, borders, icons, opacity, etc. on the component. Whenever possible, property values initialized by the client program should not be overridden.
  2. Install a `LayoutManager` on the component if necessary.
  3. Create/add any required sub-components to the component.
  4. Create/install event listeners on the component.
  5. Create/install a `PropertyChangeListener` on the component in order to detect and respond to component property changes appropriately.
  6. Install keyboard UI (mnemonics, traversal, etc.) on the component.
  7. Initialize any appropriate instance data.

  Overrides:
    `installUI` in class `javax.swing.plaf.ComponentUI`
  Parameters:
    `c` - the component where this UI delegate is being installed
  See Also:
    `uninstallUI(javax.swing.JComponent)`, `JComponent.setUI(javax.swing.plaf.ComponentUI)`, `JComponent.updateUI()`

### uninstallUI

    public void uninstallUI(javax.swing.JComponent c)

  Reverses configuration which was done on the specified component during `installUI`. This method is invoked when this `UIComponent` instance is being removed as the UI delegate for the specified component. This method should undo the configuration performed in `installUI`, being careful to leave the `JComponent` instance in a clean state (no extraneous listeners, look-and-feel-specific property objects, etc.). This should include the following:
  1. Remove any UI-set borders from the component.
  2. Remove any UI-set layout managers on the component.
  3. Remove any UI-added sub-components from the component.
  4. Remove any UI-added event/property listeners from the component.
  5. Remove any UI-installed keyboard UI from the component.
  6. Nullify any allocated instance data objects to allow for GC.

  Overrides:
    `uninstallUI` in class `javax.swing.plaf.ComponentUI`
  Parameters:
    `c` - the component from which this UI delegate is being removed; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
  See Also:
    `installUI(javax.swing.JComponent)`, `JComponent.updateUI()`

### installDefaults

    protected void installDefaults(JXHeader header)

  Installs default header properties.

  NOTE: this method is called before the children are created, so must not try to access any of those!.

  Parameters:
    `header` - the header to install.

### uninstallDefaults

    protected void uninstallDefaults(JXHeader h)

  Uninstalls the given header's default properties. This implementation does nothing.

  Parameters:
    `h` - the header to ininstall the properties from.

### installComponents

    protected void installComponents(JXHeader header)

  Creates, configures, adds contained components. PRE: header's default properties must be set before calling this.

  Parameters:
    `header` - the header to install the components into.

### uninstallComponents

    protected void uninstallComponents(JXHeader header)

  Unconfigures, removes and nulls contained components.

  Parameters:
    `header` - the header to install the components into.

### installComponentDefaults

    protected void installComponentDefaults(JXHeader header)

  Configures the component default properties from the given header.

  Parameters:
    `header` - the header to install the components into.

### uninstallComponentDefaults

    protected void uninstallComponentDefaults(JXHeader header)

  Uninstalls component defaults. This implementation does nothing.

  Parameters:
    `header` - the header to uninstall from.

### installListeners

    protected void installListeners(JXHeader header)

### uninstallListeners

    protected void uninstallListeners(JXHeader h)

### onPropertyChange

    protected void onPropertyChange(JXHeader h,
                                    java.lang.String propertyName,
                                    java.lang.Object oldValue,
                                    java.lang.Object newValue)

### createBackgroundPainter

    protected Painter createBackgroundPainter()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010. All Rights Reserved.